//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class WireguardApi {
  WireguardApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Create new WireGuard profile
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [WireGuardProfileCreateRequest] request:
  Future<Response> createProfileWithHttpInfo({ WireGuardProfileCreateRequest request }) async {
    // Verify required params are set.

    final path = r'/wg/profiles/';

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (
      nullableContentType != null &&
      nullableContentType.toLowerCase().startsWith('multipart/form-data')
    ) {
      bool hasFields = false;
      final mp = MultipartRequest(null, null);
      if (hasFields) {
        postBody = mp;
      }
    } else {
    }

    return await apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Create new WireGuard profile
  ///
  /// Parameters:
  ///
  /// * [WireGuardProfileCreateRequest] request:
  Future<WireGuardProfile> createProfile({ WireGuardProfileCreateRequest request }) async {
    final response = await createProfileWithHttpInfo( request: request );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return apiClient.deserialize(_decodeBodyBytes(response), 'WireGuardProfile') as WireGuardProfile;
        }
    return Future<WireGuardProfile>.value(null);
  }

  /// Delete WireGuarg profile
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  Future<Response> deleteProfileWithHttpInfo(String profileId) async {
    // Verify required params are set.
    if (profileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: profileId');
    }

    final path = r'/wg/profiles/{profileId}/'
      .replaceAll('{' + 'profileId' + '}', profileId.toString());

    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (
      nullableContentType != null &&
      nullableContentType.toLowerCase().startsWith('multipart/form-data')
    ) {
      bool hasFields = false;
      final mp = MultipartRequest(null, null);
      if (hasFields) {
        postBody = mp;
      }
    } else {
    }

    return await apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Delete WireGuarg profile
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  Future<void> deleteProfile(String profileId) async {
    final response = await deleteProfileWithHttpInfo(profileId);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    }
  }

  /// Retrieve WireGuarg profile
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  Future<Response> getProfileWithHttpInfo(String profileId) async {
    // Verify required params are set.
    if (profileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: profileId');
    }

    final path = r'/wg/profiles/{profileId}/'
      .replaceAll('{' + 'profileId' + '}', profileId.toString());

    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (
      nullableContentType != null &&
      nullableContentType.toLowerCase().startsWith('multipart/form-data')
    ) {
      bool hasFields = false;
      final mp = MultipartRequest(null, null);
      if (hasFields) {
        postBody = mp;
      }
    } else {
    }

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Retrieve WireGuarg profile
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  Future<WireGuardProfile> getProfile(String profileId) async {
    final response = await getProfileWithHttpInfo(profileId);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return apiClient.deserialize(_decodeBodyBytes(response), 'WireGuardProfile') as WireGuardProfile;
        }
    return Future<WireGuardProfile>.value(null);
  }

  /// Retrieve list of WireGuard profiles
  ///
  /// Note: This method returns the HTTP [Response].
  Future<Response> getProfilesWithHttpInfo() async {
    final path = r'/wg/profiles/';

    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>[];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (
      nullableContentType != null &&
      nullableContentType.toLowerCase().startsWith('multipart/form-data')
    ) {
      bool hasFields = false;
      final mp = MultipartRequest(null, null);
      if (hasFields) {
        postBody = mp;
      }
    } else {
    }

    return await apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Retrieve list of WireGuard profiles
  Future<List<WireGuardProfile>> getProfiles() async {
    final response = await getProfilesWithHttpInfo();
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return (apiClient.deserialize(_decodeBodyBytes(response), 'List<WireGuardProfile>') as List)
        .cast<WireGuardProfile>()
        .toList(growable: false);
    }
    return Future<List<WireGuardProfile>>.value(null);
  }

  /// Update profile
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  ///
  /// * [WireGuardProfileUpdateRequest] request (required):
  Future<Response> updateProfileWithHttpInfo(String profileId, WireGuardProfileUpdateRequest request) async {
    // Verify required params are set.
    if (profileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: profileId');
    }
    if (request == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: request');
    }

    final path = r'/wg/profiles/{profileId}/'
      .replaceAll('{' + 'profileId' + '}', profileId.toString());

    Object postBody = request;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    final contentTypes = <String>['application/json'];
    final nullableContentType = contentTypes.isNotEmpty ? contentTypes[0] : null;
    final authNames = <String>['Bearer'];

    if (
      nullableContentType != null &&
      nullableContentType.toLowerCase().startsWith('multipart/form-data')
    ) {
      bool hasFields = false;
      final mp = MultipartRequest(null, null);
      if (hasFields) {
        postBody = mp;
      }
    } else {
    }

    return await apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      nullableContentType,
      authNames,
    );
  }

  /// Update profile
  ///
  /// Parameters:
  ///
  /// * [String] profileId (required):
  ///
  /// * [WireGuardProfileUpdateRequest] request (required):
  Future<WireGuardProfile> updateProfile(String profileId, WireGuardProfileUpdateRequest request) async {
    final response = await updateProfileWithHttpInfo(profileId, request);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return apiClient.deserialize(_decodeBodyBytes(response), 'WireGuardProfile') as WireGuardProfile;
        }
    return Future<WireGuardProfile>.value(null);
  }
}
